<template>
  <div class="upload-batch-card">
    <h3>Upload Batch #{{ uploadBatch.id }}</h3>
    <div>
      <!-- Status -->
      <CdxInfoChip v-if="uploadBatch.finished_time" status="success"> Uploaded </CdxInfoChip>
      <CdxInfoChip v-else-if="uploadBatch.started_time" status="notice" :icon="cdxIconPlay">
        Upload in progress
      </CdxInfoChip>
      <CdxInfoChip v-else status="notice" :icon="cdxIconPause"> Pending </CdxInfoChip>
    </div>
    <div>
      <CdxInfoChip>{{
        labelsStore.labels[uploadBatch.language_qid] ?? uploadBatch.language_qid
      }}</CdxInfoChip>
    </div>
    <div>{{ uploadBatch.recordings_count }} recordings.</div>
    <div v-if="uploadBatch.recordings_count > 0" class="upload-batch-progress-bar">
      <div
        v-for="status in Object.keys(uploadBatch.status)"
        :key="status"
        :class="'upload-batch-progress-' + status"
        class="upload-batch-progression"
        :style="{
          width: (uploadBatch.status[status] / uploadBatch.recordings_count) * 100 + '%',
        }"
        :title="uploadBatch.status[status] + ' ' + status"
      ></div>
    </div>
    <router-link :to="'/my-upload-batches/' + uploadBatch.id">See details</router-link>
  </div>
</template>

<script setup>
import { CdxInfoChip } from '@wikimedia/codex'
import { cdxIconPause, cdxIconPlay } from '@wikimedia/codex-icons'
import { useLabelsStore } from '@/stores/labels'

const labelsStore = useLabelsStore()

const props = defineProps({
  uploadBatch: {
    type: Object, // the upload batch data object
    required: true,
  },
})

// Get the language label
labelsStore.fetchLabelForWikidataItem(props.uploadBatch.language_qid)
</script>

<style>
.upload-batch-card {
  background-color: beige;
  margin-bottom: 1em;
}

.upload-batch-progress-bar {
  height: 16px;
  display: flex;
  overflow: hidden;
  border-radius: 16px;
}

.upload-batch-progression {
  margin-right: 2px;
}

.upload-batch-progress-pending {
  background-color: gray;
}

.upload-batch-progress-uploading {
  background-color: orange;
}

.upload-batch-progress-uploaded {
  background-color: green;
}
</style>
